<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>arrays</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="arrayzing---the-javascript-array-cheatsheet">
      Arrayzing - The JavaScript array cheatsheet
    </h1>
    <p>
      This is a work-in-progress cheatsheet for JS arrays. Please feel free to
      leave a comment if this has helped you or you would like to suggest
      anything.
    </p>
    <ul>
      <li><a href="#user-content-create-an-array">Create an array</a></li>
      <li><a href="#user-content-empty-an-array">Empty an array</a></li>
      <li><a href="#user-content-clone-an-array">Clone an array</a></li>
      <li><a href="#user-content-get-last-item">Get last item</a></li>
      <li><a href="#user-content-remove-first-item">Remove first item</a></li>
      <li><a href="#user-content-remove-last-item">Remove last item</a></li>
      <li>
        <a href="#user-content-add-new-items-to-beginning"
          >Add new item(s) to beginning</a
        >
      </li>
      <li>
        <a href="#user-content-add-new-items-to-end">Add new item(s) to end</a>
      </li>
      <li>
        <a href="#user-content-overwrite-item-at-a-specific-index"
          >Overwrite item at a specific index</a
        >
      </li>
      <li>
        <a href="#user-content-add-new-items-at-a-specific-index"
          >Add new item(s) at a specific index</a
        >
      </li>
      <li>
        <a href="#user-content-remove-single-item-at-a-specific-index"
          >Remove single item at a specific index</a
        >
      </li>
      <li>
        <a href="#user-content-remove-several-items">Remove several items</a>
      </li>
      <li><a href="#user-content-reverse-an-array">Reverse an array</a></li>
      <li><a href="#user-content-delimit-an-array">Delimit an array</a></li>
      <li>
        <a href="#user-content-sort-in-numerical-order"
          >Sort in numerical order</a
        >
      </li>
      <li>
        <a href="#user-content-sort-in-alphabetical-order"
          >Sort in alphabetical order</a
        >
      </li>
      <li>
        <a href="#user-content-join-two-arrays-together"
          >Join two arrays together</a
        >
      </li>
      <li>
        <a href="#user-content-copy-specific-items">Copy specific item(s)</a>
      </li>
      <li>
        <a href="#user-content-augment-items-within-an-array"
          >Augment items within an array</a
        >
      </li>
      <li>
        <a href="#user-content-return-true-if-every-item-meets-a-condition"
          >Return true if every item meets a condition</a
        >
      </li>
      <li>
        <a
          href="#user-content-return-true-if-at-least-one-item-matches-a-condition"
          >Return true if at least one item matches a condition</a
        >
      </li>
      <li>
        <a href="#user-content-execute-a-function-once-per-array-item"
          >Execute a function once per array item</a
        >
      </li>
      <li><a href="#user-content-filter-an-array">Filter an array</a></li>
      <li><a href="#user-content-detect-an-array">Detect an array</a></li>
      <li><a href="#user-content-es5-and-above">ES5 and above</a></li>
      <li><a href="#user-content-es4-and-below">ES4 and below</a></li>
      <li><a href="#user-content-simple-fifo-queue">Simple FIFO queue</a></li>
      <li>
        <a href="#user-content-find-index-of-an-item">Find index of an item</a>
      </li>
      <li><a href="#user-content-es5-and-above-1">ES5 and above</a></li>
      <li><a href="#user-content-es4-and-below-1">ES4 and below</a></li>
      <li><a href="#user-content-randomise-an-array">Randomise an array</a></li>
      <li><a href="#chaining-methods">Chaining Methods</a></li>
    </ul>
    <h2 id="create-an-array">Create an array</h2>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="empty-an-array">Empty an array</h2>
    <p>Keeping references intact.</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="va">meals</span>.<span class="at">splice</span>(<span class="dv">0</span><span class="op">,</span> <span class="va">meals</span>.<span class="at">length</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>or</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="va">meals</span>.<span class="at">length</span> <span class="op">=</span> <span class="dv">0</span><span class="op">;</span></a></code></pre>
    </div>
    <h2 id="clone-an-array">Clone an array</h2>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb4-2" title="2"></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="kw">var</span> copy <span class="op">=</span> <span class="va">meals</span>.<span class="at">slice</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb4-4" title="4"><span class="co">// [&#39;breakfast&#39;, &#39;lunch&#39;, &#39;dinner&#39;]</span></a></code></pre>
    </div>
    <h2 id="get-last-item">Get last item</h2>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb5-2" title="2"></a>
<a class="sourceLine" id="cb5-3" title="3">meals[<span class="va">meals</span>.<span class="at">length</span> <span class="op">-</span> <span class="dv">1</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb5-4" title="4"><span class="co">// &#39;dinner&#39;</span></a></code></pre>
    </div>
    <p>Or</p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="va">meals</span>.<span class="at">slice</span>(<span class="op">-</span><span class="dv">1</span>)[<span class="dv">0</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb6-3" title="3"><span class="co">// &#39;dinner&#39;</span></a></code></pre>
    </div>
    <h2 id="remove-first-item">Remove first item</h2>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb7-2" title="2"></a>
<a class="sourceLine" id="cb7-3" title="3"><span class="va">meals</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb7-4" title="4"><span class="co">// &#39;breakfast&#39;</span></a>
<a class="sourceLine" id="cb7-5" title="5"></a>
<a class="sourceLine" id="cb7-6" title="6">meals<span class="op">;</span></a>
<a class="sourceLine" id="cb7-7" title="7"><span class="co">// [&#39;lunch&#39;, &#39;dinner&#39;]</span></a></code></pre>
    </div>
    <h2 id="remove-last-item">Remove last item</h2>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb8-2" title="2"></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="va">meals</span>.<span class="at">pop</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb8-4" title="4"><span class="co">// &#39;dinner&#39;</span></a>
<a class="sourceLine" id="cb8-5" title="5"></a>
<a class="sourceLine" id="cb8-6" title="6">meals<span class="op">;</span></a>
<a class="sourceLine" id="cb8-7" title="7"><span class="co">// [&#39;breakfast&#39;, &#39;lunch&#39;];</span></a></code></pre>
    </div>
    <h2 id="add-new-items-to-beginning">Add new item(s) to beginning</h2>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb9-2" title="2"></a>
<a class="sourceLine" id="cb9-3" title="3"><span class="va">meals</span>.<span class="at">unshift</span>(<span class="st">&quot;breakfast&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-4" title="4"><span class="co">// 3 - the array length</span></a>
<a class="sourceLine" id="cb9-5" title="5"></a>
<a class="sourceLine" id="cb9-6" title="6">meals<span class="op">;</span></a>
<a class="sourceLine" id="cb9-7" title="7"><span class="co">// [&#39;breakfast&#39;, &#39;lunch&#39;, &#39;dinner&#39;]</span></a></code></pre>
    </div>
    <h2 id="add-new-items-to-end">Add new item(s) to end</h2>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb10-2" title="2"></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="va">meals</span>.<span class="at">push</span>(<span class="st">&quot;supper&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-4" title="4"><span class="co">// 2</span></a>
<a class="sourceLine" id="cb10-5" title="5"></a>
<a class="sourceLine" id="cb10-6" title="6">meals<span class="op">;</span></a>
<a class="sourceLine" id="cb10-7" title="7"><span class="co">// [&#39;breakfast&#39;, &#39;lunch&#39;, &#39;dinner&#39;, &#39;supper&#39;];</span></a></code></pre>
    </div>
    <h2 id="overwrite-item-at-a-specific-index">
      Overwrite item at a specific index
    </h2>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb11-2" title="2"></a>
<a class="sourceLine" id="cb11-3" title="3">meals[<span class="dv">1</span>] <span class="op">=</span> <span class="st">&quot;brunch&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb11-4" title="4"><span class="co">// [&#39;breakfast&#39;, &#39;brunch&#39;, &#39;dinner&#39;];</span></a></code></pre>
    </div>
    <p>Or</p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb12-2" title="2"></a>
<a class="sourceLine" id="cb12-3" title="3"><span class="va">meals</span>.<span class="at">splice</span>(<span class="dv">1</span><span class="op">,</span> <span class="dv">1</span><span class="op">,</span> <span class="st">&quot;brunch&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="add-new-items-at-a-specific-index">
      Add new item(s) at a specific index
    </h2>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb13-2" title="2"></a>
<a class="sourceLine" id="cb13-3" title="3"><span class="va">meals</span>.<span class="at">splice</span>(<span class="dv">1</span><span class="op">,</span> <span class="dv">0</span><span class="op">,</span> <span class="st">&quot;brunch&quot;</span><span class="op">,</span> <span class="st">&quot;more brunch&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb13-4" title="4"><span class="co">// [&#39;breakfast&#39;, &#39;brunch&#39;, &#39;more brunch&#39;, &#39;lunch&#39;, &#39;dinner&#39;]</span></a></code></pre>
    </div>
    <h2 id="remove-single-item-at-a-specific-index">
      Remove single item at a specific index
    </h2>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb14-2" title="2"></a>
<a class="sourceLine" id="cb14-3" title="3"><span class="va">meals</span>.<span class="at">splice</span>(<span class="dv">1</span><span class="op">,</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-4" title="4"><span class="co">// [&#39;lunch&#39;]</span></a>
<a class="sourceLine" id="cb14-5" title="5"></a>
<a class="sourceLine" id="cb14-6" title="6">meals<span class="op">;</span></a>
<a class="sourceLine" id="cb14-7" title="7"><span class="co">// [&#39;breakfast&#39;, &#39;dinner&#39;]</span></a></code></pre>
    </div>
    <h2 id="remove-several-items">Remove several items</h2>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb15-2" title="2"></a>
<a class="sourceLine" id="cb15-3" title="3"><span class="va">meals</span>.<span class="at">splice</span>(<span class="dv">1</span><span class="op">,</span> <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-4" title="4"><span class="co">// [&#39;lunch&#39;, &#39;dinner&#39;]</span></a>
<a class="sourceLine" id="cb15-5" title="5"></a>
<a class="sourceLine" id="cb15-6" title="6">meals<span class="op">;</span></a>
<a class="sourceLine" id="cb15-7" title="7"><span class="co">// [&#39;breakfast&#39;]</span></a></code></pre>
    </div>
    <h2 id="reverse-an-array">Reverse an array</h2>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb16-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb16-2" title="2"></a>
<a class="sourceLine" id="cb16-3" title="3"><span class="va">meals</span>.<span class="at">reverse</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb16-4" title="4"><span class="co">// [&#39;dinner&#39;, &#39;lunch&#39;, &#39;breakfast&#39;];</span></a></code></pre>
    </div>
    <h2 id="delimit-an-array">Delimit an array</h2>
    <div class="sourceCode" id="cb17">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb17-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb17-2" title="2"></a>
<a class="sourceLine" id="cb17-3" title="3"><span class="va">meals</span>.<span class="at">join</span>(<span class="st">&quot; AND &quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb17-4" title="4"><span class="co">// &#39;breakfast AND lunch AND dinner&#39;</span></a></code></pre>
    </div>
    <h2 id="sort-in-alphabetical-order">Sort in alphabetical order</h2>
    <div class="sourceCode" id="cb18">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb18-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="st">&quot;supper&quot;</span><span class="op">,</span> <span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb18-2" title="2"></a>
<a class="sourceLine" id="cb18-3" title="3"><span class="va">meals</span>.<span class="at">sort</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb18-4" title="4"><span class="co">// [&#39;breakfast&#39;, &#39;dinner&#39;, &#39;lunch&#39;, &#39;supper&#39;]</span></a></code></pre>
    </div>
    <h2 id="sort-in-numerical-order">Sort in numerical order</h2>
    <div class="sourceCode" id="cb19">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb19-1" title="1"><span class="kw">var</span> numbers <span class="op">=</span> [<span class="dv">1438</span><span class="op">,</span> <span class="dv">2605</span><span class="op">,</span> <span class="dv">794</span><span class="op">,</span> <span class="dv">3947</span><span class="op">,</span> <span class="dv">6241</span><span class="op">,</span> <span class="dv">11745</span><span class="op">,</span> <span class="dv">2585</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb19-2" title="2"></a>
<a class="sourceLine" id="cb19-3" title="3"><span class="va">numbers</span>.<span class="at">sort</span>(<span class="kw">function</span> (a<span class="op">,</span> b) <span class="op">{</span></a>
<a class="sourceLine" id="cb19-4" title="4">  <span class="cf">return</span> a <span class="op">-</span> b<span class="op">;</span></a>
<a class="sourceLine" id="cb19-5" title="5"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb19-6" title="6"><span class="co">// [794,1438,2585,2605,3947,6241,11745]</span></a></code></pre>
    </div>
    <h2 id="join-two-arrays-together">Join two arrays together</h2>
    <div class="sourceCode" id="cb20">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb20-1" title="1"><span class="kw">var</span> dayTimeMeals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb20-2" title="2"><span class="kw">var</span> nightTimeMeals <span class="op">=</span> [<span class="st">&quot;merienda&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb20-3" title="3"></a>
<a class="sourceLine" id="cb20-4" title="4"><span class="kw">var</span> allTheMeals <span class="op">=</span> <span class="va">dayTimeMeals</span>.<span class="at">concat</span>(nightTimeMeals)<span class="op">;</span></a>
<a class="sourceLine" id="cb20-5" title="5"><span class="co">// [&#39;breakfast&#39;, &#39;lunch&#39;, &#39;merienda&#39;, &#39;dinner&#39;]</span></a></code></pre>
    </div>
    <h2 id="copy-specific-items">Copy specific item(s)</h2>
    <div class="sourceCode" id="cb21">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb21-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="st">&quot;supper&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb21-2" title="2"></a>
<a class="sourceLine" id="cb21-3" title="3">nightTimeMeals <span class="op">=</span> <span class="va">meals</span>.<span class="at">slice</span>(<span class="dv">2</span><span class="op">,</span> <span class="dv">4</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb21-4" title="4"><span class="co">// [&#39;dinner&#39;, &#39;supper&#39;]</span></a></code></pre>
    </div>
    <h2 id="augment-items-within-an-array">Augment items within an array</h2>
    <div class="sourceCode" id="cb22">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb22-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb22-2" title="2"><span class="kw">var</span> type <span class="op">=</span> [<span class="st">&quot;king&quot;</span><span class="op">,</span> <span class="st">&quot;prince&quot;</span><span class="op">,</span> <span class="st">&quot;pauper&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb22-3" title="3"></a>
<a class="sourceLine" id="cb22-4" title="4"><span class="va">meals</span>.<span class="at">map</span>(<span class="kw">function</span> (item<span class="op">,</span> i) <span class="op">{</span></a>
<a class="sourceLine" id="cb22-5" title="5">  <span class="cf">return</span> item <span class="op">+</span> <span class="st">&quot; like a &quot;</span> <span class="op">+</span> type[i]<span class="op">;</span></a>
<a class="sourceLine" id="cb22-6" title="6"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb22-7" title="7"><span class="co">// [&quot;breakfast like a king&quot;, &quot;lunch like a prince&quot;, &quot;dinner like a pauper&quot;]</span></a></code></pre>
    </div>
    <h2 id="return-true-if-every-item-meets-a-condition">
      Return true if every item meets a condition
    </h2>
    <div class="sourceCode" id="cb23">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb23-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="st">&quot;supper&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb23-2" title="2"></a>
<a class="sourceLine" id="cb23-3" title="3"><span class="va">meals</span>.<span class="at">every</span>(<span class="kw">function</span> (item) <span class="op">{</span></a>
<a class="sourceLine" id="cb23-4" title="4">  <span class="cf">return</span> <span class="va">item</span>.<span class="at">length</span> <span class="op">&gt;</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb23-5" title="5"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb23-6" title="6"><span class="co">// true</span></a>
<a class="sourceLine" id="cb23-7" title="7"></a>
<a class="sourceLine" id="cb23-8" title="8"><span class="va">meals</span>.<span class="at">every</span>(<span class="kw">function</span> (item) <span class="op">{</span></a>
<a class="sourceLine" id="cb23-9" title="9">  <span class="cf">return</span> <span class="va">item</span>.<span class="at">length</span> <span class="op">&gt;</span> <span class="dv">6</span><span class="op">;</span></a>
<a class="sourceLine" id="cb23-10" title="10"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb23-11" title="11"><span class="co">// false</span></a></code></pre>
    </div>
    <h2 id="return-true-if-at-least-one-item-matches-a-condition">
      Return true if at least one item matches a condition
    </h2>
    <div class="sourceCode" id="cb24">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb24-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="st">&quot;supper&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb24-2" title="2"></a>
<a class="sourceLine" id="cb24-3" title="3"><span class="va">meals</span>.<span class="at">some</span>(<span class="kw">function</span> (item) <span class="op">{</span></a>
<a class="sourceLine" id="cb24-4" title="4">  <span class="cf">return</span> item <span class="op">===</span> <span class="st">&quot;lunch&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb24-5" title="5"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb24-6" title="6"><span class="co">// true</span></a>
<a class="sourceLine" id="cb24-7" title="7"></a>
<a class="sourceLine" id="cb24-8" title="8"><span class="va">meals</span>.<span class="at">some</span>(<span class="kw">function</span> (item) <span class="op">{</span></a>
<a class="sourceLine" id="cb24-9" title="9">  <span class="cf">return</span> item <span class="op">===</span> <span class="st">&quot;burgers!!&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb24-10" title="10"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb24-11" title="11"><span class="co">//false</span></a></code></pre>
    </div>
    <h2 id="execute-a-function-once-per-array-item">
      Execute a function once per array item
    </h2>
    <div class="sourceCode" id="cb25">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb25-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="st">&quot;supper&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb25-2" title="2"></a>
<a class="sourceLine" id="cb25-3" title="3"><span class="va">meals</span>.<span class="at">forEach</span>(<span class="kw">function</span> (currentValue<span class="op">,</span> index<span class="op">,</span> arr) <span class="op">{</span></a>
<a class="sourceLine" id="cb25-4" title="4">  <span class="va">console</span>.<span class="at">log</span>(index<span class="op">,</span> currentValue<span class="op">,</span> arr)<span class="op">;</span></a>
<a class="sourceLine" id="cb25-5" title="5"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="filter-an-array">Filter an array</h2>
    <div class="sourceCode" id="cb26">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb26-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="st">&quot;supper&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb26-2" title="2"></a>
<a class="sourceLine" id="cb26-3" title="3"><span class="va">meals</span>.<span class="at">filter</span>(<span class="kw">function</span> (item) <span class="op">{</span></a>
<a class="sourceLine" id="cb26-4" title="4">  <span class="cf">return</span> item <span class="op">!==</span> <span class="st">&quot;breakfast&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb26-5" title="5"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb26-6" title="6"><span class="co">// [&#39;lunch&#39;, &#39;dinner&#39;, &#39;supper&#39;];</span></a></code></pre>
    </div>
    <h2 id="detect-an-array">Detect an array</h2>
    <h3 id="es5-and-above">ES5 and above</h3>
    <div class="sourceCode" id="cb27">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb27-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb27-2" title="2"></a>
<a class="sourceLine" id="cb27-3" title="3"><span class="va">Array</span>.<span class="at">isArray</span>(meals)<span class="op">;</span></a>
<a class="sourceLine" id="cb27-4" title="4"><span class="co">// true</span></a></code></pre>
    </div>
    <h3 id="es4-and-below">ES4 and below</h3>
    <div class="sourceCode" id="cb28">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb28-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;lunch&quot;</span><span class="op">,</span> <span class="st">&quot;dinner&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb28-2" title="2"></a>
<a class="sourceLine" id="cb28-3" title="3"><span class="kw">function</span> <span class="at">isArray</span>(arr) <span class="op">{</span></a>
<a class="sourceLine" id="cb28-4" title="4">  <span class="cf">return</span> <span class="op">!!</span>(<span class="va">Object</span>.<span class="va">prototype</span>.<span class="va">toString</span>.<span class="at">call</span>(arr) <span class="op">===</span> <span class="st">&quot;[object Array]&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb28-5" title="5"><span class="op">}</span></a>
<a class="sourceLine" id="cb28-6" title="6"></a>
<a class="sourceLine" id="cb28-7" title="7"><span class="at">isArray</span>(meals)<span class="op">;</span></a>
<a class="sourceLine" id="cb28-8" title="8"><span class="co">// true</span></a></code></pre>
    </div>
    <h2 id="simple-fifo-queue">Simple FIFO queue</h2>
    <div class="sourceCode" id="cb29">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb29-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;elevenses&quot;</span><span class="op">,</span> <span class="st">&quot;brunch&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb29-2" title="2"></a>
<a class="sourceLine" id="cb29-3" title="3"><span class="va">meals</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb29-4" title="4"><span class="va">meals</span>.<span class="at">push</span>(<span class="st">&quot;lunch&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb29-5" title="5"></a>
<a class="sourceLine" id="cb29-6" title="6"><span class="co">// [&#39;elevenses&#39;, &#39;brunch&#39;, &#39;lunch&#39;]</span></a>
<a class="sourceLine" id="cb29-7" title="7"></a>
<a class="sourceLine" id="cb29-8" title="8"><span class="va">meals</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb29-9" title="9"><span class="va">meals</span>.<span class="at">push</span>(<span class="st">&quot;afternoon tea&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb29-10" title="10"></a>
<a class="sourceLine" id="cb29-11" title="11"><span class="co">// [&#39;brunch&#39;, &#39;lunch&#39;, &#39;afternoon tea&#39;]</span></a>
<a class="sourceLine" id="cb29-12" title="12"><span class="co">// ... and so on ...</span></a></code></pre>
    </div>
    <h2 id="find-index-of-an-item">Find index of an item</h2>
    <h2 id="es5-and-above-1">ES5 and above</h2>
    <div class="sourceCode" id="cb30">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb30-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;elevenses&quot;</span><span class="op">,</span> <span class="st">&quot;brunch&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb30-2" title="2"><span class="va">meals</span>.<span class="at">indexOf</span>(<span class="st">&quot;brunch&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb30-3" title="3"><span class="co">// 2</span></a></code></pre>
    </div>
    <h3 id="es4-and-below-1">ES4 and below</h3>
    <div class="sourceCode" id="cb31">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb31-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [<span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="st">&quot;elevenses&quot;</span><span class="op">,</span> <span class="st">&quot;brunch&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb31-2" title="2"></a>
<a class="sourceLine" id="cb31-3" title="3"><span class="kw">function</span> <span class="at">inArray</span>(arr<span class="op">,</span> item) <span class="op">{</span></a>
<a class="sourceLine" id="cb31-4" title="4">  <span class="kw">var</span> found <span class="op">=</span> <span class="dv">-1</span><span class="op">,</span></a>
<a class="sourceLine" id="cb31-5" title="5">    i <span class="op">=</span> <span class="va">arr</span>.<span class="at">length</span><span class="op">;</span></a>
<a class="sourceLine" id="cb31-6" title="6"></a>
<a class="sourceLine" id="cb31-7" title="7">  <span class="cf">while</span> (<span class="op">--</span>i <span class="op">&gt;=</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb31-8" title="8">    <span class="cf">if</span> (arr[i] <span class="op">===</span> item) <span class="op">{</span></a>
<a class="sourceLine" id="cb31-9" title="9">      found <span class="op">=</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb31-10" title="10">      <span class="cf">break</span><span class="op">;</span></a>
<a class="sourceLine" id="cb31-11" title="11">    <span class="op">}</span></a>
<a class="sourceLine" id="cb31-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb31-13" title="13">  <span class="cf">return</span> found<span class="op">;</span></a>
<a class="sourceLine" id="cb31-14" title="14"><span class="op">}</span></a>
<a class="sourceLine" id="cb31-15" title="15"></a>
<a class="sourceLine" id="cb31-16" title="16"><span class="at">inArray</span>(meals<span class="op">,</span> <span class="st">&quot;brunch&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb31-17" title="17"><span class="co">// 2 - the index of the item in the array</span></a>
<a class="sourceLine" id="cb31-18" title="18"></a>
<a class="sourceLine" id="cb31-19" title="19"><span class="at">inArray</span>(meals<span class="op">,</span> <span class="st">&quot;dinner&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb31-20" title="20"><span class="co">// -1</span></a></code></pre>
    </div>
    <h2 id="randomise-an-array">Randomise an array</h2>
    <div class="sourceCode" id="cb32">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb32-1" title="1"><span class="kw">function</span> <span class="at">randomiseArray</span>(arr) <span class="op">{</span></a>
<a class="sourceLine" id="cb32-2" title="2">  <span class="kw">var</span> buffer <span class="op">=</span> []<span class="op">,</span></a>
<a class="sourceLine" id="cb32-3" title="3">    start<span class="op">;</span></a>
<a class="sourceLine" id="cb32-4" title="4"></a>
<a class="sourceLine" id="cb32-5" title="5">  <span class="cf">for</span> (<span class="kw">var</span> i <span class="op">=</span> <span class="va">arr</span>.<span class="at">length</span><span class="op">;</span> i <span class="op">&gt;=</span> <span class="va">arr</span>.<span class="at">length</span> <span class="op">&amp;&amp;</span> i <span class="op">&gt;</span> <span class="dv">0</span><span class="op">;</span> i<span class="op">--</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb32-6" title="6">    start <span class="op">=</span> <span class="va">Math</span>.<span class="at">floor</span>(<span class="va">Math</span>.<span class="at">random</span>() <span class="op">*</span> <span class="va">arr</span>.<span class="at">length</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb32-7" title="7">    <span class="va">buffer</span>.<span class="at">push</span>(<span class="va">arr</span>.<span class="at">splice</span>(start<span class="op">,</span> <span class="dv">1</span>)[<span class="dv">0</span>])<span class="op">;</span></a>
<a class="sourceLine" id="cb32-8" title="8">  <span class="op">}</span></a>
<a class="sourceLine" id="cb32-9" title="9"></a>
<a class="sourceLine" id="cb32-10" title="10">  <span class="cf">return</span> buffer<span class="op">;</span></a>
<a class="sourceLine" id="cb32-11" title="11"><span class="op">}</span></a>
<a class="sourceLine" id="cb32-12" title="12"></a>
<a class="sourceLine" id="cb32-13" title="13"><span class="at">randomiseArray</span>([<span class="dv">0</span><span class="op">,</span> <span class="dv">1</span><span class="op">,</span> <span class="dv">2</span><span class="op">,</span> <span class="dv">3</span><span class="op">,</span> <span class="dv">4</span>])<span class="op">;</span></a>
<a class="sourceLine" id="cb32-14" title="14"><span class="co">// [2,1,0,3,4]</span></a>
<a class="sourceLine" id="cb32-15" title="15"></a>
<a class="sourceLine" id="cb32-16" title="16"><span class="at">randomiseArray</span>([<span class="dv">0</span><span class="op">,</span> <span class="dv">1</span><span class="op">,</span> <span class="dv">2</span><span class="op">,</span> <span class="dv">3</span><span class="op">,</span> <span class="dv">4</span>])<span class="op">;</span></a>
<a class="sourceLine" id="cb32-17" title="17"><span class="co">// [3,2,1,4,0]</span></a>
<a class="sourceLine" id="cb32-18" title="18"></a>
<a class="sourceLine" id="cb32-19" title="19"><span class="at">randomiseArray</span>([<span class="dv">0</span><span class="op">,</span> <span class="dv">1</span><span class="op">,</span> <span class="dv">2</span><span class="op">,</span> <span class="dv">3</span><span class="op">,</span> <span class="dv">4</span>])<span class="op">;</span></a>
<a class="sourceLine" id="cb32-20" title="20"><span class="co">// [1,2,4,0,3]</span></a></code></pre>
    </div>
    <h1 id="chaining-methods">Chaining methods</h1>
    <div class="sourceCode" id="cb33">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb33-1" title="1"><span class="kw">var</span> meals <span class="op">=</span> [</a>
<a class="sourceLine" id="cb33-2" title="2">  <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Full English&quot;</span><span class="op">,</span> <span class="dt">calories</span><span class="op">:</span> <span class="dv">1500</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb33-3" title="3">  <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Colacao&quot;</span><span class="op">,</span> <span class="dt">calories</span><span class="op">:</span> <span class="dv">260</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb33-4" title="4">  <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;breakfast&quot;</span><span class="op">,</span> <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Croissant and jam&quot;</span><span class="op">,</span> <span class="dt">calories</span><span class="op">:</span> <span class="dv">520</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb33-5" title="5">  <span class="op">{</span></a>
<a class="sourceLine" id="cb33-6" title="6">    <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;breakfast&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-7" title="7">    <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Granola with Greek yoghurt and blueberries&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-8" title="8">    <span class="dt">calories</span><span class="op">:</span> <span class="dv">680</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-9" title="9">  <span class="op">},</span></a>
<a class="sourceLine" id="cb33-10" title="10">  <span class="op">{</span></a>
<a class="sourceLine" id="cb33-11" title="11">    <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;brinner&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-12" title="12">    <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Shepherds Pie with strawberry yoghurt&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-13" title="13">    <span class="dt">calories</span><span class="op">:</span> <span class="dv">915</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-14" title="14">  <span class="op">},</span></a>
<a class="sourceLine" id="cb33-15" title="15">  <span class="op">{</span></a>
<a class="sourceLine" id="cb33-16" title="16">    <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;brinner&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-17" title="17">    <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Milky Porridge with beef and green beans&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-18" title="18">    <span class="dt">calories</span><span class="op">:</span> <span class="dv">875</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-19" title="19">  <span class="op">},</span></a>
<a class="sourceLine" id="cb33-20" title="20">  <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Phad Thai&quot;</span><span class="op">,</span> <span class="dt">calories</span><span class="op">:</span> <span class="dv">750</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb33-21" title="21">  <span class="op">{</span> <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;dinner&quot;</span><span class="op">,</span> <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Chicken Katsu curry and rice&quot;</span><span class="op">,</span> <span class="dt">calories</span><span class="op">:</span> <span class="dv">830</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb33-22" title="22">]<span class="op">;</span></a>
<a class="sourceLine" id="cb33-23" title="23"></a>
<a class="sourceLine" id="cb33-24" title="24"><span class="kw">function</span> <span class="at">getMealsByMaxCalories</span>(meals<span class="op">,</span> maxCalories<span class="op">,</span> dailyAllowance) <span class="op">{</span></a>
<a class="sourceLine" id="cb33-25" title="25">  <span class="cf">return</span> meals</a>
<a class="sourceLine" id="cb33-26" title="26">    .<span class="at">filter</span>(<span class="kw">function</span> (meal) <span class="op">{</span></a>
<a class="sourceLine" id="cb33-27" title="27">      <span class="cf">return</span> <span class="va">meal</span>.<span class="at">calories</span> <span class="op">&lt;=</span> maxCalories<span class="op">;</span></a>
<a class="sourceLine" id="cb33-28" title="28">    <span class="op">}</span>)</a>
<a class="sourceLine" id="cb33-29" title="29">    .<span class="at">map</span>(<span class="kw">function</span> (meal) <span class="op">{</span></a>
<a class="sourceLine" id="cb33-30" title="30">      <span class="cf">return</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb33-31" title="31">        <span class="dt">name</span><span class="op">:</span> <span class="va">meal</span>.<span class="at">name</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-32" title="32">        <span class="dt">calories</span><span class="op">:</span> <span class="va">meal</span>.<span class="at">calories</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-33" title="33">        <span class="dt">percentageOfDailyAllowance</span><span class="op">:</span> (<span class="va">meal</span>.<span class="at">calories</span> / dailyAllowance) <span class="op">*</span> <span class="dv">100</span><span class="op">,</span></a>
<a class="sourceLine" id="cb33-34" title="34">      <span class="op">};</span></a>
<a class="sourceLine" id="cb33-35" title="35">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb33-36" title="36"><span class="op">}</span></a>
<a class="sourceLine" id="cb33-37" title="37"></a>
<a class="sourceLine" id="cb33-38" title="38"><span class="at">getMealsByMaxCalories</span>(meals<span class="op">,</span> <span class="dv">850</span><span class="op">,</span> <span class="dv">2000</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb33-39" title="39"></a>
<a class="sourceLine" id="cb33-40" title="40"><span class="co">/*</span></a>
<a class="sourceLine" id="cb33-41" title="41"><span class="co">[</span></a>
<a class="sourceLine" id="cb33-42" title="42"><span class="co">  {</span></a>
<a class="sourceLine" id="cb33-43" title="43"><span class="co">    &quot;name&quot;: &quot;Colacao&quot;,</span></a>
<a class="sourceLine" id="cb33-44" title="44"><span class="co">    &quot;calories&quot;: 260,</span></a>
<a class="sourceLine" id="cb33-45" title="45"><span class="co">    &quot;percentageOfDailyAllowance&quot;: 13</span></a>
<a class="sourceLine" id="cb33-46" title="46"><span class="co">  },</span></a>
<a class="sourceLine" id="cb33-47" title="47"><span class="co">  {</span></a>
<a class="sourceLine" id="cb33-48" title="48"><span class="co">    &quot;name&quot;: &quot;Croissant and jam&quot;,</span></a>
<a class="sourceLine" id="cb33-49" title="49"><span class="co">    &quot;calories&quot;: 520,</span></a>
<a class="sourceLine" id="cb33-50" title="50"><span class="co">    &quot;percentageOfDailyAllowance&quot;: 26</span></a>
<a class="sourceLine" id="cb33-51" title="51"><span class="co">  },</span></a>
<a class="sourceLine" id="cb33-52" title="52"><span class="co">  {</span></a>
<a class="sourceLine" id="cb33-53" title="53"><span class="co">    &quot;name&quot;: &quot;Granola with Greek yoghurt and blueberries&quot;,</span></a>
<a class="sourceLine" id="cb33-54" title="54"><span class="co">    &quot;calories&quot;: 680,</span></a>
<a class="sourceLine" id="cb33-55" title="55"><span class="co">    &quot;percentageOfDailyAllowance&quot;: 34</span></a>
<a class="sourceLine" id="cb33-56" title="56"><span class="co">  },</span></a>
<a class="sourceLine" id="cb33-57" title="57"><span class="co">  {</span></a>
<a class="sourceLine" id="cb33-58" title="58"><span class="co">    &quot;name&quot;: &quot;Phad Thai&quot;,</span></a>
<a class="sourceLine" id="cb33-59" title="59"><span class="co">    &quot;calories&quot;: 750,</span></a>
<a class="sourceLine" id="cb33-60" title="60"><span class="co">    &quot;percentageOfDailyAllowance&quot;: 37.5</span></a>
<a class="sourceLine" id="cb33-61" title="61"><span class="co">  }</span></a>
<a class="sourceLine" id="cb33-62" title="62"><span class="co">]</span></a>
<a class="sourceLine" id="cb33-63" title="63"><span class="co">*/</span></a></code></pre>
    </div>
  </body>
</html>
